#ifndef _PW_PWHANDLER_H
#define _PW_PWHANDLER_H

/*
	ProWesS, PROGS Windowing System

	Definition of functions for writing object type handlers

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 21 January 1995
*/

#ifndef _PW_PROWESS_H
#include "ProWesS.h"
#endif
#ifndef _PW_PWOBJECT_H
#include "PWObject.h"
#endif
#ifndef _PW_PWSYSTEM_H
#include "PWSystem.h"
#endif
#ifndef _PW_PWTYPEDEF_H
#include "PWTypeDef.h"
#endif

Error PWHandleKeyPress(PWSystem *system);
Error PWGetType(PWType type, PWTypeDef **rettype);
int *PWSkipTag(int *taglist);
Error PWAllocate(PWSystem *system, Size size, void **ret);
Error PWRelease(PWObject object, void *base);

void PWpixel2point(pt *xfactor, pt *yfactor);
void PWpoint2pixel(pt *xfactor, pt *yfactor);
int PF2xpix(pt x);
int PF2ypix(pt x);
pt xpix2PF(short x);
pt ypix2PF(short x);
pt PFxround(pt x);
pt PFyround(pt x);

typedef struct _Defines {
	char *name; 					/* name of constant, no prefix */
	Error (*Handle)(struct _Defines *possible, char *value);
	void (*Post)(void *data);		/* post processing routine */
	void *data; 					/* place where data should be put */
	char *set;						/* set to TRUE when data set (if !NULL) */
} Defines;

#define PW_DEFINE_COLOUR		((Error (*)(Defines*,char*))1)
#define PW_DEFINE_BOOLEAN		((Error (*)(Defines*,char*))2)
#define PW_DEFINE_CHARACTER 	((Error (*)(Defines*,char*))3)
#define PW_DEFINE_SHORT 		((Error (*)(Defines*,char*))4)
#define PW_DEFINE_INT			((Error (*)(Defines*,char*))5)
#define PW_DEFINE_PT			((Error (*)(Defines*,char*))6)
#define PW_DEFINE_FONT			((Error (*)(Defines*,char*))7)

Error PWHandleDefine(char *prefix, Defines *possible, char *name, char *value);

#endif _PW_PWHANDLER_H
