/*
	ProWesS, PROGS Windowing System

	ProWesS test for canvas type

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 25 April 1995
*/

#include <sms.h>
#include <win.h>
#include <ProWesS.h>

#define FONT "Courier"
#define STRING "drag"
#define SIZE short2pt(10)

Error dragend(PWObject object, CanvasInfo *rinfo)
{
	return PWChange(object,PW_POINTER,SPRITE_HAND,
						   PW_CANVAS_TIMEOUT, 0,
						   PW_CANVAS_ACTION_TIMEOUT, NULL,
						   NULL);
}

Error hit(PWObject object, CanvasInfo *rinfo)
{
	return PWChange(object,PW_POINTER,SPRITE_WAKE,NULL);
}

Error drawtxt(PWObject object, CanvasInfo *rinfo)
{
	Gstate gid=rinfo->gstate;

	PFColourGray(gid,pt_hundred);
	PFMoveTo(gid,rinfo->xpos,rinfo->ypos);

	/* draw the contents (just some text) */
	PFFontLoad(gid,FONT);
	PFFontScale(gid,SIZE);
	PFStringShow(gid,STRING);
	PFPageShow(gid);
	return ERR_OK;
}

Error dragdo(PWObject object, CanvasInfo *rinfo)
{
	PWChange(object,PW_CANVAS_TIMEOUT, 25,
					PW_CANVAS_ACTION_TIMEOUT, drawtxt,
					NULL);
	SMSBeep(20000,20);
	return PWChange(object,PW_POINTER,SPRITE_LEFT,NULL);
}

void init()
{
	PWObject obj;

	LinkPROforma();
	PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
				PW_OUTLINE_QUIT,
				PW_OUTLINE_QUIT_KEYPRESS, 27,
				PW_OUTLINE_SLEEP,
				PW_CURSOR_SEPARATE, TRUE,
				NULL);
	PWCreate(obj, NULL, PW_TYPE_CANVAS,
				PW_CANVAS_SIZE_PIX, 100,45,
				PW_CANVAS_ACTION_HIT, hit,
				PW_CANVAS_ACTION_DODRAG, dragdo,
				PW_CANVAS_ACTION_DRAGEND, dragend,
				NULL);
	PWActivate(obj);
}
