/*
	ProWesS, PROGS Windowing System
	PROforma, PROGS Font & Raster Manager

	test menu - to test/fix a bug in menus (disappearing scroll bar (?))

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 December 1996
*/

#include <str.h>
#include <ProWesS.h>

#define catch(x) do { if (err=(x)) return err; } while (0)

Error init()
{
	Error err;
	Gstate gstate;
	PWObject outl=NULL, menu, glue, text;
	char font[PF_MAXFONTNAME];

	LinkPROforma();

	catch( PWCreate(NULL,&outl,PW_TYPE_OUTLINE,
				PW_OUTLINE_QUIT,
				PW_OUTLINE_QUIT_KEYPRESS, 27,
				NULL) );

	catch( PWCreate(outl,&menu,PW_TYPE_MENU,
				PW_MENU_UNIQUE,
				PW_MENU_VISIBLE_LINES, 5,
				PW_SCALE_FACTOR, 0,
				NULL) );

	/* fill the menu */

	PWQuery(outl, PW_SYSTEM_GSTATE, &gstate);
	PFFontCountAll(gstate, NULL);
	while (!PFFontNextName(gstate, font))
		catch( PWChange(menu, PW_MENU_ADD_COPY, font, NULL) );

	/* activate the window */
	return PWActivate(outl);
}
