/*
	ProWesS, PROGS Windowing System

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 28 August 1995
*/

#include "mem.h"

#include "ProWesS.h"

#define MAXLEN 50

Error addmenu(PWObject object)
{
	PWObject menu;
	char str[MAXLEN];
	PWQuery(object,PW_GLOBAL_AUXILIARY,&menu);
	PWChange(object,PW_EDLINE_GET,MAXLEN,str,NULL);
	PWChange(menu,PW_MENU_ADD_COPY,str,
				  NULL);
}

void init()
{
	PWObject obj,edline,menu;

	PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP,
				PW_OUTLINE_QUIT,
				NULL);
	PWCreate(obj,&edline,PW_TYPE_EDLINE,
				PW_EDLINE_SET, "type text here",
				PW_EDLINE_MAXLENGTH, MAXLEN,
				PW_EDLINE_ACTION_AFTER,addmenu,
				NULL);
	PWCreate(obj,NULL,PW_TYPE_SEPARATOR,
				PW_POSITION_BELOW, edline,
				NULL);
	PWCreate(obj,&menu,PW_TYPE_MENU,
				PW_MENU_SORT_COMPARE, &STRCompareCI,
				PW_MENU_VISIBLE_LINES, 10,
				NULL);
	PWChange(obj,PW_GLOBAL_AUXILIARY,menu,NULL);
	PWActivate(obj);
}
